#ifndef CONFIG_HPP_
#define CONFIG_HPP_

#include "boost/config.hpp"

#if defined( __GNUC__ )
    #define LIB_GNUC
#elif defined(_WIN32) || defined(__WIN32__) || defined(WIN32)
    #define LIB_WINDOWS
#endif

#if defined( LIB_GNUC ) && defined( _HAVE_GCC_VISIBILITY )
    #define LIB_EXPORT __attribute__ ((visibility("default")))
    #define LIB_IMPORT
#elif defined( LIB_WINDOWS )
    #define LIB_EXPORT __declspec(dllexport)
    #define LIB_IMPORT __declspec(dllimport)
#else
    #define LIB_EXPORT
    #define LIB_IMPORT
#endif

#if defined( LIB_DYN_LINK )
    #ifdef LIB_SOURCE
        #define LIB_DECL LIB_EXPORT
    #else
        #define LIB_DECL LIB_IMPORT
    #endif
#else
    #define LIB_DECL
#endif

#endif /* CONFIG_HPP_ */
